#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Sep 20 12:23:56 2022
@author: arb
BY-NC 4.0
"""
import pygame

VERBOSE = True #mode bavard

# définition de la fenêtre du jeu
pygame.init()
ecran = pygame.display.set_mode((900, 600))
pygame.display.set_caption("saute-moutons NSI LLB 23-24")

#chargement des images
fond = pygame.image.load("fichiers/prairie.jpg").convert()
moutonB = pygame.image.load("fichiers/B.png").convert_alpha()
moutonN = pygame.image.load("fichiers/N.png").convert_alpha()
win = pygame.image.load("fichiers/shaun.png").convert_alpha()
reset = pygame.image.load("fichiers/reset.png").convert_alpha()
undo = pygame.image.load("fichiers/undo.png").convert_alpha()

pygame.display.set_icon(moutonB)


def initecran():#on enlève tous les moutons
    ecran.blit(fond, (0, 0))
    ecran.blit(reset, (20, 453))
    #ecran.blit(undo, (750, 450))

    # Un peu de lecture dans la fenêtre
    police = pygame.font.Font(None,20)#taille et police du texte
    police2 = pygame.font.Font(None,15)
    
    texte1 = police.render("Emmène tous les moutons blancs à droite et tous les moutons noirs à gauche !  ", True, pygame.Color("#FFFF00"))
    ecran.blit(texte1, (20, 20))
    texte2 = police.render("Les moutons blancs peuvent se déplacer vers la droite vers une case vide ou en sautant par dessus un mouton noir.", True, pygame.Color("#FFFF00"))
    ecran.blit(texte2, (20, 35))
    texte3 = police.render("Les moutons noirs peuvent se déplacer vers la gauche vers une case vide ou en sautant par dessus un mouton blanc.", True, pygame.Color("#FFFF00"))
    ecran.blit(texte3, (20, 50))
    texte4 = police2.render("ARB 2023 BY-NC 4.0 d'après une idée originale de C. Declerc INSPE la Réunion", True, pygame.Color("#FFFFFF") )
    ecran.blit(texte4, (250, 550))
    

#Quelques fonctions
def majMouton(): #On replace les moutpons au bon endroit
    for case in range(9):
        if jeu[case] == 'B':
            ecran.blit(moutonB, (20+case*95, 200))
        elif jeu[case] == 'N':
            ecran.blit(moutonN, (20+case*95, 200))
    gagne()
    
def gagne() : #pour vérifier si le jeu est dans la configuration gagnante
    if jeu == ['N', 'N', 'N', 'N', 'X', 'B', 'B', 'B', 'B']:
        initecran()
        ecran.blit(win, (285, 300))
        
def boutonreset(): #pour ramener les moutons à la position initiale
    global  jeu
    jeu = ['B', 'B', 'B', 'B', 'X', 'N', 'N', 'N', 'N']

#######################################
# la fonction undo, ne fonctionne pas #
#######################################

def boutonundo():
    global jeu
    jeu = ['B', 'B', 'B', 'B', 'X', 'N', 'N', 'N', 'N'] #début de l'activité
    

##################################################
# la fonction qui implémente le saut d'un mouton #
##################################################
    
def saute(numeroMouton) : # les moutons sont numérotés de 0 à 8
    
    
    if jeu[numeroMouton] =='B' : #si le mouton est blanc
        if numeroMouton<8 and jeu[numeroMouton+1] == 'X' : #si la case suivante est vide
            jeu[numeroMouton], jeu[numeroMouton+1] = jeu[numeroMouton+1], jeu[numeroMouton] #le mouton avance d'une case
        elif numeroMouton <7 and jeu[numeroMouton+1] == 'N' and jeu[numeroMouton+2] == 'X' : #si le mouton suivant est noir et la case d'après est vide
            jeu[numeroMouton], jeu[numeroMouton+2] = jeu[numeroMouton+2], jeu[numeroMouton] # le mouton saute
            
    elif jeu[numeroMouton] == 'N' : #si le mouton est noir
        if numeroMouton >0 and jeu[numeroMouton-1] == 'X' :
            jeu[numeroMouton], jeu[numeroMouton-1] = jeu[numeroMouton-1], jeu[numeroMouton] 
        elif numeroMouton >1 and jeu[numeroMouton-1] == 'B' and jeu[numeroMouton-2] == 'X' : 
            jeu[numeroMouton], jeu[numeroMouton-2] = jeu[numeroMouton-2], jeu[numeroMouton] 
    
    print(historique)
        
#################################################################
# La boucle principale qui gère les actions liées aux évènements#
#       Fonctionne très bien, ne pas modifier !                 #
#################################################################

jeu = ['B', 'B', 'B', 'B', 'X', 'N', 'N', 'N', 'N'] #initialisation du jeu
historique = [] #une liste pour se souvenir des coups joués
continuer = True

while continuer :
    initecran()
    majMouton()
    
    for event in pygame.event.get() :
        # quitter le jeu
        if event.type == pygame.QUIT:
            continuer = False #pour quitter la boucle principale
        
        if event.type == pygame.MOUSEBUTTONUP : # se déclenche par un clic gauche
            x = event.pos[0]
            y = event.pos[1]
            
            if y >200 and y < 300 : #on clic sur un des moutons
                caseClic = (x-20)//95  #le numéro du mouton (de 0 à 8)
                saute(caseClic)   
                
            if y > 453 and y < 580 and x > 20 and x < 152 : #bouton reset     
                boutonreset()
                if VERBOSE :
                    print(jeu)
            
            if y > 450 and y < 580 and x > 750 and x < 880 : #bouton undo    
                boutonundo()

    pygame.display.flip() #mise à jour de l'écran de jeu
    
for event in pygame.event.get() :
    # quitter le jeu
    if event.type == pygame.QUIT:
        continuer = False
pygame.quit()
                